/*  --- Copyright University of Sussex 1990.  All rights reserved. ---------
 > File:            C.pwm/lib/ved/term/vedpwmsun.p
 > Purpose:         Configure Ved for the Sun Poplog Window Manager.
 > Author:          Ben Rubinstein, Apr  1 1986 (see revisions)
 > Documentation:   HELP *VEDPWM
 > Related Files:   LIB *PWMSUNUTILS *PWMSGRAPHICS
					LIB *VEDPWMSUNSCREEN *VEDPWMSUNKEYS
 */
compile_mode :pop11 +strict;

section;

uses-by_name vedpwmsunscreen, vedpwmsunkeys;

define vars vedpwmsun();
	veduseterm("pwmsun") ->;
	identfn -> vedpwmsun;
enddefine;

if iscaller(vedsetup) then vedpwmsun() endif;

endsection;


/* --- Revision History ---------------------------------------------------
--- Andreas Schoter, Mar 28 1990
		Repackaged the library to work with -vedinitterm-
--- Rob Duncan, Oct 30 1989
		Rewrote to work with new VED startup procedure: packaged everything
		into procedure -vedpwmsun-, added explicit calls to -vedvi200screen-
		and -vedsunkeys- and deleted some unnecessary assignments.
		Sectionised.
--- Ben Rubinstein, Jun 20 1986 - fixed vedsunrefresh, vved...pad for new
								sequence set
--- Mark Rubinstein, May  1 1986 - changed the construction of vedstatusheader
	so that there are no hi bit characters in the file.
*/
