/* --- Copyright University of Sussex 1989. All rights reserved. ----------
 * File:            S.sun3/src/alisp.s
 * Purpose:
 * Author:          John Williams (see revisions)
 */


#_<

#_INCLUDE 'declare.ph'

constant	_setstklen_diff
	;

>_#

/********************* wrapping structures ***********************************/

	.text
	.long	Ltext_end-Ltext_start, C_LAB(Sys$-objmod_pad_key)
Ltext_start:
	.data
	.long	Ldata_end-Ldata_start, C_LAB(Sys$-objmod_pad_key)
Ldata_start:

/**************************************************************************/

	.text

DEF_C_LAB (_setstklen)
	movl	a6@+,d1			;;; d1 = nresults
	addl	a6@+,d1			;;; d1 = saved stklen + nresults + 6
	subql	#6,d1			;;; d1 = desired stacklength (bytes)
	movl	I_LAB(_userhi), d0	;;; d0 = value of _userhi
	subl	d1,d0			;;; d0 = desired a6 = _userhi - d1
	cmpl	a6,d0			;;; compare d0 - a6
	bnes	C_LAB(_setstklen_diff)	;;; carry on if different
	rts				;;; otherwise return

DEF_C_LAB (_setstklen_diff)
	bgts	L_ERAS			;;; erase if d0 > a6
L_PUSH:
	movl	#C_LAB(nil),a6@-	;;; push NIL
	cmpl	a6,d0			;;; compare
	bnes	L_PUSH			;;; loop again unless same
	rts

L_ERAS:
	movl	d0,a6			;;; set a6 to desired stacklength
	rts


/*************** end labels for wrapping structures **************************/

	.text
Ltext_end:
	.data
Ldata_end:

/**************************************************************************/



/* --- Revision History ---------------------------------------------------
--- John Gibson, Aug 17 1989
	Replaced # EXEC ... # ENDEXEC with #_< ... >_#
--- John Gibson, Aug 22 1988
	Wrapping structures now use -objmod_pad_key-
--- John Gibson, Jan 17 1988
	Added 'wrapping' strings to enable object files from .s files to
	be mixed in with those from .p source.
		Replaced all references to 'poplog' labels with macros
	C_LAB, I_LAB, etc applied to identifier names, and added appropriate
	declarations between #_< ... >_#, etc.
 */
