$! --- Copyright University of Sussex 1994. All rights reserved. ----------
$! File:            C.vms/com/cd.com
$! Purpose:         CHANGE DIRECTORY Can be used with or without brackets
$! Author:          Unknown, ??? (see revisions)

$ ! CD FOO first tries SET DEF [.FOO]. If no such directory it tries
$ ! SET DEF [FOO]
$ ! If there's still no directory, it complains, and returns to original

$ showdir = 1
$ if p1 .eqs. "-NOSHOW"
$ then
$	showdir = 0
$	p1 = p2
$ endif

$ old = f$trnlnm("sys$disk") + f$directory()
$ on warning then goto NOSUCHDIR

$ if p1 .eqs. ""
$ then
$	! NO DIRECTORY SPECIFIED -- GO TO LOGIN DIRECTORY
$ 	p1 = "sys$login"
$	goto SETDEF
$ endif
$ if p1 .eqs. ".."
$ then
$	! SIMULATE UNIX .. = SUPERDIRECTORY
$	p1 = "[-]"
$	goto SETDEF
$ endif

$ if f$trnlnm(p1) .nes. "" then p1 = p1 + ":"

$ device = ""
$ length = f$length(p1)
$ if f$locate(":",p1) .ne. length
$ then
$	! DIRECTORY NAME INCLUDES COLON, I.E DEVICE
$	colon = f$locate(":",p1)
$	device = f$extract(0,colon,p1)
$	p1 = f$extract(colon+1,length-(colon+1),p1)
$	if p1 .eqs. ""
$	then
$		if f$trnlnm(device) .eqs. "" .or. f$trnlnm(device,,,,,"CONCEALED")
$ 		then
$			p1 = "[000000]"
$		else
$			p1 = device
$			goto SETDEF
$		endif
$ 	endif
$	device = device + ":"
$ endif

$ ! REMOVE ANY BRACKETS
$ if f$locate("[",p1) .eq. 0 then p1 = f$extract(1,f$length(p1)-2,p1)
$ p2 = p1

$ if device .eqs. ""
$ then
$	! TRY SUBDIRECTORY
$	if f$locate(".",p1) .ne. 0 then p1 = "." + p1
$	p1 = "[" + p1 + "]"
$	if f$parse(p1) .nes. "" then goto SETDEF
$	device = "sys$disk:"
$ endif

$ if f$locate(".",p2) .ne. 0
$ then
$	! TRY TOP-LEVEL DIRECTORY
$	p1 = device + "[" + p2 + "]"
	if f$parse(p1) .nes. "" then goto SETDEF
$ endif

$ NOSUCHDIR:
$ set default 'old'
$ write sys$error "No such directory"
$ show default
$ exit %X1001C04A		! RMS-E-DNF

$ SETDEF:
$ set default 'p1'
$ if showdir then show default


$! --- Revision History ---------------------------------------------------
$! --- John Gibson, Dec 20 1994
$!		Completely rewritten (so it copes properly with a number of things)
